## tillitis-tkey-device-signer 1.0.2

=== Makefile ===
# Check for OS, if not macos assume linux
UNAME_S := $(shell uname -s)
ifeq ($(UNAME_S),Darwin)
	shasum = shasum -a 512
else
	shasum = sha512sum
endif

IMAGE=ghcr.io/tillitis/tkey-builder:4

OBJCOPY ?= llvm-objcopy

P := $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))
LIBDIR ?= $(P)/../tkey-libs

CC = clang

INCLUDE = $(LIBDIR)/include

# If you want libcommon's qemu_puts() et cetera to output something on our QEMU
# debug port, use -DQEMU_DEBUG below
CFLAGS = -target riscv32-unknown-none-elf -march=rv32iczmmul -mabi=ilp32 -mcmodel=medany \
   -static -std=gnu99 -O2 -ffast-math -fno-common -fno-builtin-printf \
   -fno-builtin-putchar -nostdlib -mno-relax -flto -g \
   -Wall -Werror=implicit-function-declaration \
   -I $(INCLUDE) -I $(LIBDIR) #-DQEMU_DEBUG

ifneq ($(TKEY_SIGNER_APP_NO_TOUCH),)
CFLAGS := $(CFLAGS) -DTKEY_SIGNER_APP_NO_TOUCH
endif

AS = clang
ASFLAGS = -target riscv32-unknown-none-elf -march=rv32iczmmul -mabi=ilp32 -mcmodel=medany -mno-relax

LDFLAGS=-T $(LIBDIR)/app.lds -L $(LIBDIR) -lcommon -lcrt0


.PHONY: all
all: signer/app.bin check-signer-hash

# Create compile_commands.json for clangd and LSP
.PHONY: clangd
clangd: compile_commands.json
compile_commands.json:
	$(MAKE) clean
	bear -- make signer/app.bin

# Turn elf into bin for device
%.bin: %.elf
	$(OBJCOPY) --input-target=elf32-littleriscv --output-target=binary $^ $@
	chmod a-x $@

show-%-hash: %/app.bin
	@echo "Device app digest:"
	@$(shasum) $$(dirname $^)/app.bin

check-signer-hash: signer/app.bin show-signer-hash
	@echo "Expected device app digest: "
	@cat signer/app.bin.sha512
	$(shasum) -c signer/app.bin.sha512

.PHONY: check
check:
	clang-tidy -header-filter=.* -checks=cert-* signer/*.[ch] -- $(CFLAGS)

# Simple ed25519 signer app
SIGNEROBJS=signer/main.o signer/app_proto.o
signer/app.elf: $(SIGNEROBJS)
	$(CC) $(CFLAGS) $(SIGNEROBJS) $(LDFLAGS) -L $(LIBDIR)/monocypher -lmonocypher -I $(LIBDIR) -o $@
$(SIGNEROBJS): $(INCLUDE)/tkey/tk1_mem.h signer/app_proto.h

.PHONY: clean
clean:
	rm -f signer/app.bin signer/app.elf $(SIGNEROBJS)

# Uses ../.clang-format
FMTFILES=signer/*.[ch]

.PHONY: fmt
fmt:
	clang-format --dry-run --ferror-limit=0 $(FMTFILES)
	clang-format --verbose -i $(FMTFILES)
.PHONY: checkfmt
checkfmt:
	clang-format --dry-run --ferror-limit=0 --Werror $(FMTFILES)

.PHONY: podman
podman:
	podman run --arch=amd64 --rm --mount type=bind,source=$(CURDIR),target=/src --mount type=bind,source=$(LIBDIR),target=/tkey-libs -w /src -it $(IMAGE) make -j

=== debian/changelog ===
tillitis-tkey-device-signer (1.0.2-2) unstable; urgency=medium

  * Bump debian/* copyright years.
  * Pin to clang/llvm 19 adding clang-tidy patch.
  * Make package team-maintained by pkg-security.
  * Add Static-Built-Using.
  * salsa-ci: Build with custom tkey-libs apt.  Build rdep tkey-ssh-agent.

 -- Simon Josefsson <simon@josefsson.org>  Mon, 03 Feb 2025 13:35:23 +0100

tillitis-tkey-device-signer (1.0.2-1) unstable; urgency=medium

  * Initial release (Closes: #1087429)

 -- Simon Josefsson <simon@josefsson.org>  Wed, 13 Nov 2024 12:51:16 +0100

=== debian/control ===
Source: tillitis-tkey-device-signer
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders:
 Simon Josefsson <simon@josefsson.org>,
Build-Depends:
 debhelper-compat (= 13),
 clang-19,
 clang-tidy-19 <!nocheck>,
 lld-19,
 llvm-19,
 tillitis-tkey-libs,
Standards-Version: 4.7.0
Section: libs
Homepage: https://github.com/tillitis/tkey-device-signer
Vcs-Browser: https://salsa.debian.org/debian/tillitis-tkey-device-signer
Vcs-Git: https://salsa.debian.org/debian/tillitis-tkey-device-signer.git
Rules-Requires-Root: no

Package: tillitis-tkey-device-signer
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Static-Built-Using: tillitis-tkey-libs (= 0.1.2-2)
Description: Tillitis TKey Signer device application
 Tillitis TKey Signer
 .
 The TKey `signer` device application is an ed25519 signing tool. It
 can sign messages up to 4 kByte. It is, for instance, used by the
 [tkey-ssh-agent](https://github.com/tillitis/tkey-ssh-agent) for SSH
 authentication and by
 [tkey-sign](https://github.com/tillitis/tkey-sign-cli) for doing
 digital signatures of files.
 .
 This package contains the device signer application.  Normally this
 is only useful as a build dependency for other applications that
 embed the device application, for loading onto the device.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_build:
	make CC="clang-19 -fuse-ld=lld-19" AR=llvm-ar-19 OBJCOPY=llvm-objcopy-19 LIBDIR=/usr/share/tillitis/tkey-libs/

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	make CLANG_TIDY=clang-tidy-19 check LIBDIR=/usr/share/tillitis/tkey-libs/
endif

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
  https://github.com/tillitis/tkey-device-signer/tags \
  (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
